      subroutine emmsnda(y,n,p,ng,ncov,
     &pro,mu,sigma,delta,tau,ev,vv,
     &loglik,lk,clust,itmax,epsilon,error)
      integer n,p,ng,error,ncov,itmax
      integer clust(*)
      double precision y(n,*), mu(p,*), sigma(p,p,*)
      double precision delta(p,*), pro(*), loglik, lk(*)
      double precision tau(n,*),  ev(n,*), vv(n,*)
      double precision sumtau(ng)!,corr(p,p,ng)
      integer h,i, it
      double precision        zero, one, two, epsilon
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      do h=1,ng
        sumtau(h)=zero
        do i=1,n
         tau(i,h)=zero
         if(clust(i) .eq. h) tau(i,h)=one
         sumtau(h)=sumtau(h)+tau(i,h)
        enddo
        pro(h)=sumtau(h)/dble(n)
      enddo
      call mstepmvn(y,n,p,ng,ncov,tau,sumtau
     &      mu,sigma)
      call skew(y,n,p,ng,tau,sumtau,mu,sigma,delta)
      error=0
      do 1000 it=1,itmax
         lk(it)=zero
      call estepmsnda(y,n,p,ng,pro,mu,sigma,delta,
     &tau,sumtau,ev,vv,loglik,clust,error)
      if(error.ne.0) then
        error=3
        return
      endif
      lk(it)=loglik
      call mstepmsn(y,n,p,ng,ncov,tau,sumtau,ev,vv,
     &mu,sigma,delta)
        if(it.ge.itmax) error=1
        if(it .le. 10) goto 1000
        if( (abs(lk(it-10)-loglik) .lt. (abs(lk(it-10))*epsilon))
     &   .and.(abs(lk(it-1)-loglik) .lt. (abs(lk(it-1))*epsilon)))
     &    goto 5000
1000  continue
5000  continue
      return
      end
      subroutine estepmsnda(x,n,p,G,pro,mu,sigma,delta,
     &tau,sumtau,ev,vv,loglik,clust,error)
      implicit NONE
      integer            n, p, G, error,clust(*)
      double precision   loglik,pro(*)
      double precision   x(n,*), tau(n,  *  ),delta(p,*)
      double precision   mu(p,*), Sigma(p,p,*)
      double precision   ev(n,*), vv(n,*),sumtau(*)
      integer            i,  h
      double precision        zero,one
      parameter              (zero = 0.d0,one=1.0d0)
      error  = 0
      call denmsn2(x,n,p,g,mu,sigma,delta,
     &tau,ev,vv,error)
      if(error .ne. 0) then
        error=22
        return
      endif
      loglik = zero
      call gettau(tau,pro,loglik,n,g,error)
      if(error .ne. 0) then
        error=23
        return
      endif
      do h=1,g
        sumtau(h)=zero
        do i=1,n
         tau(i,h)=zero
         if(clust(i) .eq. h) tau(i,h)=one
         sumtau(h)=sumtau(h)+tau(i,h)
        enddo
      enddo
      return
      end
