      subroutine emmvtda(y,n,p,ng,ncov,
     &pro,mu,sigma,dof,tau,xuu,
     &loglik,lk,clust,itmax,epsilon,error)
      implicit none
      integer n,p,ng,error,itmax,ncov,clust(*)
      double precision y(n,*), mu(p,*), sigma(p,p,*), dof(*)
      double precision pro(*), loglik,lk(*)
      double precision tau(n,*)
      double precision sumtau(ng),xuu(n,*),sumxuu(ng)
      double precision epsilon,sumxuuln(ng)
      integer h,i,it
      double precision zero, one, two
      parameter        (zero = 0.d0, one = 1.d0, two = 2.d0)
      do h=1,ng
        sumtau(h)=zero
        do i=1,n
         tau(i,h)=zero
         if(clust(i) .eq. h) tau(i,h)=one
         sumtau(h)=sumtau(h)+tau(i,h)
        enddo
        pro(h)=sumtau(h)/dble(n)
        dof(h)=two*two
      enddo
      call mstepmvn(y,n,p,ng,ncov,tau,sumtau,
     &      mu,sigma)
      if(error.ne.0) return
      error=0
      do 1000 it=1,itmax
          lk(it)=zero
      call estepmvtda(y,n,p,ng,pro,mu,sigma,dof,
     &tau,sumtau,xuu,sumxuu,sumxuuln,loglik,clust,error)
      if(error.ne.0) then
      error=2
      return
      endif
      call mstepmvt(y,n,p,ng,ncov,tau,sumtau,xuu,sumxuu,sumxuuln,
     &mu,sigma,dof)
         if(it.ge.itmax) error=1
         if(it .le. 10) goto 1000
         if(abs(lk(it-10)-loglik) .lt. (abs(lk(it-10))*epsilon) )
     &   goto 5000
1000  continue
5000  continue
      return
      end
      subroutine estepmvtda(x,n,p,g,pro,mu,sigma,dof,
     &tau,sumtau,xuu,sumxuu,sumxuuln,loglik,clust,info)
      implicit NONE
      integer            n, p, g, info,clust(*)
      double precision   loglik
      double precision   x(n,*), tau(n,  *  ),dof(*)
      double precision   mu(p,*), Sigma(p,p,*), pro(  *  )
      double precision   xuu(n,*), sumxuu(*),sumtau(*),sumxuuln(*)
      integer                 i,  k
      double precision        zero, one, two,temp
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      double precision   mydigamma
      external mydigamma
      info  = 0
      call denmvt2(x,n,p,g,mu,sigma,dof,tau,xuu,info)
      if(info .ne. 0) then
       info=5
       return
      endif
      loglik = zero
      call gettau(tau,pro,loglik,n,g,info)
      do k=1,g
        sumtau(k)=zero
        sumxuu(k)=zero
        sumxuuln(k)=zero
        do i=1,n
          tau(i,k)=zero
          if(clust(i)==k) tau(i,k)=one
          sumtau(k)=sumtau(k)+tau(i,k)
          sumxuu(k)  =sumxuu(k)+tau(i,k)*xuu(i,k)
          sumxuuln(k)=sumxuuln(k)+tau(i,k)*(log(xuu(i,k))-xuu(i,k))
        enddo
        temp = (dble(p) +dof(k))/two;
        sumxuuln(k) = sumxuuln(k)-(log(temp)-mydigamma(temp))*sumtau(k)
      end do
      return
      end
